function [pmin, porder]=AICselection(y,pmax);

% PFIND.M
% Lutz Kilian
% University of Michigan
% April 1997
%
% Code written for p=1,...,pmax. Must be adapted slightly if we allow for p=0.


crit=zeros(1,pmax);
[t,q]=size(y);

XMAX=ones(1,t-pmax);
for i=1:pmax
	XMAX=[XMAX; y(pmax+1-i:t-i,:)'];
end;

for jj=1:pmax

	X=XMAX(1:jj*q+1,:);
    Y=y(pmax+1:t,:)';   

	B=Y*X'*inv(X*X');        
    SIGMA=(Y-B*X)*(Y-B*X)'/(t-pmax);
    [row,column]=size(B);
    np=length(reshape(B,row*column,1));
    np = np/q;
    
   % Calculating value of aic(jj)
   crit(jj)=log(SIGMA(1,1))+np*2/(t-pmax);    		  % aic     
   %crit(jj)=log(SIGMA(1,1))+np*log(t-pmax)/(t-pmax);  % sic value
	
end;

[pmin,porder]=min(crit);
       
