function output = varianceLoop(theta, y, sigma2, outtype, np)

% Compute the likelihood function and the time series of estimated variances.
[T,K]=size(y);

sig2=sigma2*ones(T,1);sig2(1)=sigma2;
Lik=ones(T,1);
Lik(1) = .5 * (log(2*pi) + log(sig2(1)) + (y(1)^2)/sig2(1));

for i=2:T
    if np == 3, sig2(i) = theta(1) +  theta(2) * sig2(i-1) + theta(3) * y(i-1)^2;
    elseif np == 4, sig2(i) = theta(1) + theta(2) * sig2(i-1) + theta(3) * y(i-1)^2 + theta(4) * x(i-1);
    end
    Lik(i) = .5 * (log(2*pi) + log(sig2(i)) + ((y(i)^2) / sig2(i)));
end

if outtype==1
    output = sum(Lik(1:T,:));
elseif outtype==2
    output = Lik(1:T,:);
else
    output = sig2;
end